﻿using Connected.Annotations;
using Connected.Data.DataProtection;
using Connected.Data.Schema;
using Connected.Data.Sharding;
using Connected.Data.Storage;
using Connected.Entities.Storage;
using Microsoft.Extensions.DependencyInjection;

[assembly: MicroService(MicroServiceType.Sys)]

namespace Connected.Data;

internal sealed class DataStartup : Startup
{
	protected override void OnConfigureServices(IServiceCollection services)
	{
		services.AddScoped(typeof(ISchemaService), typeof(SchemaService));
		services.AddScoped(typeof(IShardingService), typeof(ShardingService));
		services.AddScoped(typeof(IConnectionProvider), typeof(ConnectionProvider));
		services.AddScoped(typeof(IStorageProvider), typeof(StorageProvider));
		services.AddScoped(typeof(IEntityProtectionService), typeof(EntityProtectionService));
	}
}
